﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace maraton_ns
{
    public partial class maraton_form : Form
    {
        struct FutoAdat
        {
            public int rajtszam;
            public int helyezes;
            public DateTime bruttoido;
            public DateTime nettoido;
        }
        FutoAdat[] Futok = new FutoAdat[200];
        int letszam = 0;
        
        public maraton_form()
        {
            InitializeComponent();
        }

        private void Beolvasas_Btn_Click(object sender, EventArgs e)
        {
            FileStream fajl = new FileStream("futasadat.txt", FileMode.Open);
            StreamReader olvaso = new StreamReader(fajl);
            while (!olvaso.EndOfStream)
            {
                Futok[letszam].rajtszam = int.Parse(olvaso.ReadLine());
                Futok[letszam].helyezes = int.Parse(olvaso.ReadLine());
                Futok[letszam].bruttoido = DateTime.Parse(olvaso.ReadLine());
                Futok[letszam].nettoido = DateTime.Parse(olvaso.ReadLine());
                letszam++;
            }
            olvaso.Close();
            fajl.Close();
            kiir_Tbox.Clear();
            kiir_Tbox.Text = "Beolvasás megtörtént.\r\n";
        }

        private void fel2_Btn_Click(object sender, EventArgs e)
        {
            kiir_Tbox.Text += "2. feladat\r\n";
            kiir_Tbox.Text += "A futók száma: " + letszam.ToString() + "\r\n";

        }

        private void fel3_Btn_Click(object sender, EventArgs e)
        {
            kiir_Tbox.Text += "3. feladat\r\n";
            sorsz_Tbox.Enabled = true;
            kiir_Tbox.Text += "Adja meg a rajtszámot, majd üssön Entert!\r\n";
        }

        private void sorsz_Tbox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyValue == 13)
            {
                int rajtszamkeres = int.Parse(sorsz_Tbox.Text);
                int i = 0;
                while ((Futok[i].rajtszam != rajtszamkeres) && (i < letszam)) i++;
                if (i < letszam)
                    kiir_Tbox.Text += Futok[i].rajtszam.ToString() + " " +
                                      Futok[i].bruttoido.ToLongTimeString() + " " +
                                      Futok[i].nettoido.ToLongTimeString() + "\r\n";
                else
                    kiir_Tbox.Text += "Nem volt ilyen rajtszámú versenyző!\r\n";
            }
        }

        private void fel4_Btn_Click(object sender, EventArgs e)
        {
            String nemertekcelba = "";
            kiir_Tbox.Text += "4. feladat\r\n";
            for (int i = 0; i < letszam; i++)
                if (Futok[i].helyezes == 0)
                    nemertekcelba += Futok[i].rajtszam.ToString() + " ";
            if (nemertekcelba == "")
                kiir_Tbox.Text += "Minden versenyző célba ért.\r\n";
            else
                kiir_Tbox.Text += "Nem ért célba: " + nemertekcelba + "\r\n";
        }

        private void fel5_Btn_Click(object sender, EventArgs e)
        {
            kiir_Tbox.Text += "5. feladat\r\n";
            int max = 0;
            TimeSpan maxido = Futok[max].bruttoido - Futok[max].nettoido;
            for (int i = 1; i < letszam; i++)
            {
                if (maxido < Futok[i].bruttoido - Futok[i].nettoido)
                {
                    max = i;
                    maxido = Futok[max].bruttoido - Futok[max].nettoido;
                }
            }
            kiir_Tbox.Text += "A legtöbbet váró futó rajtszáma: " + Futok[max].rajtszam.ToString() + ", " +
                "a várakozási ideje: " + maxido.ToString("hh':'mm':'ss");  

        }
    }
}
